package compbio.cassandra.readers;

import org.apache.log4j.Logger;

import com.datastax.driver.core.ResultSet;
import com.datastax.driver.core.Session;
import com.datastax.driver.core.exceptions.QueryExecutionException;
import com.datastax.driver.core.exceptions.QueryValidationException;
import compbio.cassandra.CassandraNativeConnector;

public class CassandraReader {
	private static long earlestDate = 0;
	private Session session;
	protected static Logger log = Logger.getLogger(CassandraNativeConnector.class);

	public CassandraReader() {
		Session inis = CassandraNativeConnector.getSession();
		setSession(inis);
	}

	public void setSession(Session s) {
		assert s != null;
		session = s;
	}

	protected ResultSet CassandraQuery(String command) {
		try {
			ResultSet results = session.execute(command);
			return results;
		} catch (QueryExecutionException e) {
			String mess = "CassandraUserManagerImpl.findAllUsers: query execution exception...";
			System.out.println(mess);
			log.error(mess);
			log.error(e.getLocalizedMessage(), e.getCause());
			return null;
		} catch (QueryValidationException e) {
			String mess = "CassandraUserManagerImpl.findAllUsers: query validation exception... Command: " + command;
			System.out.println(mess);
			log.error(mess);
			log.error(e.getLocalizedMessage(), e.getCause());
			return null;
		}

	}

	/*
	 * find the earliest date in the database
	 */
	public static long earliestDate() {
		earlestDate = CassandraNativeConnector.getEarliestDateInDB();
		return earlestDate;
	}

}
